#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
	
#define TAILLE_MAX_PHRASE 	128
#define	FICHIER_PIPE1		"/tmp/testfifo1"
#define	FICHIER_PIPE2		"/tmp/testfifo2"
	
int main(int argc, char *argv[])
{
	char	phrase[TAILLE_MAX_PHRASE];
	int	tube1;
	int	tube2;
	strcpy(phrase, "abcdABCD1234");
	mkfifo(FICHIER_PIPE1, S_IRWXU|O_CREAT);
	mkfifo(FICHIER_PIPE2, S_IRWXU|O_CREAT);
	tube1 = open(FICHIER_PIPE1, O_WRONLY);
	tube2 = open(FICHIER_PIPE2, O_RDONLY);
	if (tube1 < 0)
	{
		fprintf(stderr, "Erreur à l'ouverture de tube1 en écriture...\n");
		exit(-1);
	}
	if (tube2 < 0)
	{
		fprintf(stderr, "Erreur à l'ouverture de tube1 en lecture...\n");
		exit(-1);
	}
	printf("ENVOI: Phrase avant modifications=%s\n", phrase);
	/* on envoie la phrase... */
	write(tube1, phrase, strlen(phrase)+1);
	/* et on attend la réponse */
	read(tube2, phrase, 128);
	printf("ENVOI: Phrase après modifications=%s\n", phrase);
	close(tube1);
	close(tube2);
	return(0);
}
